<?php

/**
 *
 * Standard GSALES 2 PDF Mahnwesen Template ab 05/2022 für mPDF 8
 * MPDF generiert die PDF-Datei anhand von HTML Markup, welches durch ein SMARTY Template (tpl.def_dunning.tpl) bereitgestellt wird. Siehe unten: $smartyTemplate
 *
 * Das bisherhige Template für die Generierung der PDF Mahnungen mittels FPDF steht weiterhin zur Verwendung unter tpl.def_dunning_legacy.php zur Verfügung.
 *
 */

// Anhand vom Datei-ort ermitteln ob es sich um das GSALES Standard-Template handelt oder um ein vom Kunden im Template-Editor selbst angelegtest
// GSALES Standard-Template befindet sich in /lib/tpl/out_pdf/ - Kunden-Templates befinden sich in /DATA/
$booCustomTemplate = true;
if (strpos(__FILE__, 'out_pdf')) $booCustomTemplate = false;

if ($booCustomTemplate) require_once __DIR__ . '/../lib/3rdparty/vendor/autoload.php';
else require_once __DIR__ . '/../../3rdparty/vendor/autoload.php';

// GSALES Konfigurationseinstellungen für die Generierung von PDF Dokumenten
$arrPDFConfig = array();

// PDF Hintergrund
$arrPDFConfig['use_stationery_pdf'] = $this->refCore->cfg->v('pdf_dunning_stationary');
$arrPDFConfig['stationery_pdf_file'] = $this->refCore->cfg->v('path_absolute').$this->refCore->cfg->v('pdf_dunning_stationary_file'); # bitte pdf Datei entsprechend hochladen!

// Mini Absender
$arrPDFConfig['print_minisender'] = $this->refCore->cfg->v('pdf_dunning_printminisender');

/*
    Firmenlogo einbinden
	Möglich sind folgende Dateiformate
	- JPG Bilder (Graustufenbilder, Truecolor 24 Bit, CMYK 32 Bit)
	- PNG Bilder (Graustufenbilder 8 Bit & 256 Graustufen, Farbpaletten, Truecolor 24 Bit)
*/
$arrPDFConfig['use_picture'] = $this->refCore->cfg->v('pdf_dunning_picture');
$arrPDFConfig['picture_file'] = $this->refCore->cfg->v('path_absolute').$this->refCore->cfg->v('pdf_dunning_picture_file'); # GSALES Logo als Beispiel, bitte eigene Verwenden damit diese bei Updates nicht versehentlich überschrieben wird
$arrPDFConfig['picture_width'] = $this->refCore->cfg->v('pdf_dunning_picture_width');
$arrPDFConfig['picture_posX'] = $this->refCore->cfg->v('pdf_dunning_picture_posx');
$arrPDFConfig['picture_posY'] = $this->refCore->cfg->v('pdf_dunning_picture_posy');

// Fußzeilenblöcke
$arrPDFConfig['print_footer_blocks'] = $this->refCore->cfg->v('pdf_invoice_printfooter');

// Fußzeilenblöcke im GSALES 1 Stil = Einfache Textfelder aus Konfiguration
$arrPDFConfig['footer_head_1'] = $this->refCore->cfg->v('pdf_footer_headline_1');
$arrPDFConfig['footer_1'] = $this->refCore->cfg->v('pdf_footer_1');
$arrPDFConfig['footer_head_2'] = $this->refCore->cfg->v('pdf_footer_headline_2');
$arrPDFConfig['footer_2'] = $this->refCore->cfg->v('pdf_footer_2');
$arrPDFConfig['footer_head_3'] = $this->refCore->cfg->v('pdf_footer_headline_3');
$arrPDFConfig['footer_3'] = $this->refCore->cfg->v('pdf_footer_3');
$arrPDFConfig['footer_head_4'] = $this->refCore->cfg->v('pdf_footer_headline_4');
$arrPDFConfig['footer_4'] = $this->refCore->cfg->v('pdf_footer_4');

// Fußzeilenblöcke Content (verwendet den Konfigurationsreiter "Meine Daten")
if ($this->refCore->cfg->v('me_ustidnr') != '' && $this->refCore->cfg->v('me_taxno')){
	$arrTaxFooter = array('headline'=>'Steuernummern', 'txt'=>'USt-IdNr. '.$this->refCore->cfg->v('me_ustidnr')."\nSt.-Nr. ".$this->refCore->cfg->v('me_taxno'));
} else {
	if ($this->refCore->cfg->v('me_ustidnr') != '') $arrTaxFooter = array('headline'=>'USt-IdNr.', 'txt'=>$this->refCore->cfg->v('me_ustidnr'));
	else $arrTaxFooter = array('headline'=>'Steuernummer', 'txt'=>$this->refCore->cfg->v('me_taxno'));
}

$arrContactFooter = array('headline'=>'Anschrift', 'txt'=>$this->refCore->cfg->v('me_company')."\n".$this->refCore->cfg->v('me_address')."\n".$this->refCore->cfg->v('me_countrycode').$this->refCore->cfg->v('me_zip').' '.$this->refCore->cfg->v('me_city'));
if ($this->refCore->cfg->v('me_owner') != '' || $this->refCore->cfg->v('me_manager') != '') $arrContactFooter['txt'] .= "\n";
if ($this->refCore->cfg->v('me_owner') != '') $arrContactFooter['txt'] .= "\n".'Inh. '.$this->refCore->cfg->v('me_owner');
if ($this->refCore->cfg->v('me_manager') != '') $arrContactFooter['txt'] .= "\n".'GF '.$this->refCore->cfg->v('me_manager');

$arrBankFooter = array('headline'=>'Bankverbindung', 'txt'=>'');
if ($this->refCore->cfg->v('me_bank') != '') $arrBankFooter['txt'] .= $this->refCore->cfg->v('me_bank')."\n";
if ($this->refCore->cfg->v('me_bankaccount') != '') $arrBankFooter['txt'] .= 'Konto '.$this->refCore->cfg->v('me_bankaccount')."\n";
if ($this->refCore->cfg->v('me_bankcode') != '') $arrBankFooter['txt'] .= 'BLZ '.$this->refCore->cfg->v('me_bankcode')."\n";
if ($this->refCore->cfg->v('me_bankiban') != '') $arrBankFooter['txt'] .= 'IBAN '.$this->refCore->cfg->v('me_bankiban')."\n";
if ($this->refCore->cfg->v('me_bankbic') != '') $arrBankFooter['txt'] .= 'BIC '.$this->refCore->cfg->v('me_bankbic')."\n";

$arrPDFConfig['arrFooter'] = array(
	$arrContactFooter,
	array('headline'=>'Kontakt', 'txt'=>"Tel. ".$this->refCore->cfg->v('me_phone')."\nFax ".$this->refCore->cfg->v('me_fax')."\n".$this->refCore->cfg->v('me_mail')."\n".$this->refCore->cfg->v('me_web')),
	$arrTaxFooter,
	$arrBankFooter
);

// Absender (kann auch über die GSALES Konfiguration beinflusst werden)
$arrPDFConfig['company_sender'] = $this->refCore->cfg->v('me_company').' - '.$this->refCore->cfg->v('me_address').' - '.trim($this->refCore->cfg->v('me_countrycode').' '.$this->refCore->cfg->v('me_zip')).' '.$this->refCore->cfg->v('me_city');

// Labels
$arrPDFConfig['label_1_step'] = $this->refCore->cfg->v('pdf_d_label_1_step');
$arrPDFConfig['label_2_step'] = $this->refCore->cfg->v('pdf_d_label_2_step');
$arrPDFConfig['label_3_step'] = $this->refCore->cfg->v('pdf_d_label_3_step');
$arrPDFConfig['label_date'] = $this->refCore->cfg->v('pdf_d_label_date');
$arrPDFConfig['label_customerno'] = $this->refCore->cfg->v('pdf_d_label_customerno');
$arrPDFConfig['label_page'] = $this->refCore->cfg->v('pdf_d_label_page');
$arrPDFConfig['label_invoiceno'] = $this->refCore->cfg->v('pdf_d_label_invoiceno');
$arrPDFConfig['label_invoicedate'] = $this->refCore->cfg->v('pdf_d_label_invoicedate');
$arrPDFConfig['label_invoicepart'] = $this->refCore->cfg->v('pdf_d_label_invoicepart');
$arrPDFConfig['label_invoicetopay'] = $this->refCore->cfg->v('pdf_d_label_invoicetopay');
$arrPDFConfig['label_subtotal'] = $this->refCore->cfg->v('pdf_d_label_subtotal');
$arrPDFConfig['label_total'] = $this->refCore->cfg->v('pdf_d_label_total');

// Im Blanko keine Bilder, Briefpapier und Fußzeilenblöcke ausgeben
if ($booBlanko){
	$arrPDFConfig['use_stationery_pdf'] = false;
	$arrPDFConfig['use_picture'] = false;
	$arrPDFConfig['print_footer_blocks'] = false;
}

// Smarty die Rechnungsdaten und -konfiguration übergeben
$this->refCore->smarty->assign('pdf_config',$arrPDFConfig);
$this->refCore->smarty->assign('pdf_data',$var_array);

$defaultConfig = (new Mpdf\Config\ConfigVariables())->getDefaults();
$fontDirs = $defaultConfig['fontDir'];

$defaultFontConfig = (new Mpdf\Config\FontVariables())->getDefaults();
$fontData = $defaultFontConfig['fontdata'];

$strFontsDir = __DIR__ . '/../../../DATA//mpdf_fonts';
if ($booCustomTemplate) $strFontsDir = __DIR__ . '/../DATA//mpdf_fonts';

$booPDFA = false;
$strFontToUse = 'arial.ttf';

$mpdf = new \Mpdf\Mpdf([

	'fontDir' => array_merge($fontDirs, [
		$strFontsDir
	]),

	'fontdata' => $fontData + [
			'arial' => [
				'R' => $strFontToUse,
			]
		],
	'mode' => 'utf-8',
	'PDFA' => $booPDFA,
	'PDFAauto' => $booPDFA,
]);

// Briefpapier im Hintergrund einbinden?
if($arrPDFConfig['use_stationery_pdf']) $mpdf->SetDocTemplate($arrPDFConfig['stationery_pdf_file'], true);

$smartyTemplate = $this->refCore->cfg->v('path_absolute').'lib/tpl/out_pdf/tpl.def_dunning.tpl';

# Für die Verwendung eines eigenen Smarty-Templates folgende Zeile einkommentieren und den Dateinamen anpassen
# $smartyTemplate = $this->refCore->cfg->v('path_absolute').'DATA/my.def_dunning.tpl';

$mpdf->WriteHTML($this->refCore->smarty->fetch($smartyTemplate));

// PDF Datei ausgeben
if ($booBlanko) $mpdf->Output($savetoblanko,'F');
else $mpdf->Output($saveto,'F');

unset($mpdf);